%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This calculates the solution of the model from the optimum
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all

cd 'C:\Users\john\Desktop\mem key\Fin Frictions\JPT\bonds'
addpath 'C:\Users\john\Desktop\mem key\Fin Frictions\JPT'
addpath 'C:\Users\john\Desktop\mem key\bond pricing\matlab\JPTreplication'

% loading the relevant dataset
load data_bonds
T=length(y);

load -ascii XOUT14_bonds.txt;
xout=XOUT14_bonds; xout2=sortrows(xout,1);

x0=bounds14_bonds(([xout2(1,2:end)]));


logpost_bonds_14(bounds14_bondsINV(x0),T,y)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% x0(12)=.9998;
%%%%%%%%%%%%%%%%
param=x0;
RHO=0.75;

alpha=.33;
Fbeta=.35;
gamma100=.47; gamma=gamma100/100;
beta=100/(Fbeta+100); lbeta=log(beta); betaI=1/(1-beta);
pdbar=-log(1-exp(lbeta+(1-RHO)*gamma));
pss=2.5/400;
logprior=logprior_full14_bonds(param);
param(25)=param(25)*param(28);
ALPHA=param(28);
Z_bar=(1-ALPHA)/(1-RHO);

param(25)=param(25)*sqrt(1-param(16)^2);
param(26)=param(26)-.5;

param(4)=0;
param(33)=0;

%
% param(24)=0;
% param(25)=0;
% param(27)=0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Solution of the model

    [G1,C,M,eu,SDX,H,rbar,B,~,~,Br,GAM0,PSI]=model_full14_bonds(param);
    
    SDXa=SDX; SDXa(9,7)=SDXa(7,9); SDXa(7,9)=0;
    IRF=M*SDX;
    for j=1:2000
        IRF(:,:,j+1)=G1*IRF(:,:,j);
    end

    IRFa=-squeeze(IRF(:,9,:)); IRFb=squeeze(IRF(:,2,:));
    IRFc=squeeze(IRF(:,8,:)); IRFd=squeeze(IRF(:,1,:));

% plot([squeeze(IRF0(8,7,:)) squeeze(IRF(8,7,:))])
    
% MM=M([1,3,5,6,7,8,9,14],:)*SDX;
% bsxfun(@times,(MM.^2),1./sum((MM.^2),2))
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % get bond prices
        %% note that the constant is included for Z, but not the inflation target
        
        PHI=G1;
        PSI=M;
        
        NY=length(G1);
        RU=36;
        UC=40;
        b=20; %% this is u in the model file (should maybe change...)
        p=6;
        z=15;
        Z=23; %% RRA_Z in the model file
        
        G_R = zeros(1,NY); G_R(RU)=1;
        G_UC = zeros(1,NY); G_UC(UC)=1; G_UC(z)=-RHO;
        G_b = zeros(1,NY); G_b(b)=1;
        G_pi = zeros(1,NY); G_pi(p)=1;
        G_z = zeros(1,NY); G_z(Z)=1;
        G_eR=zeros(1,NY); G_eR(49)=1;
        G_epi=zeros(1,NY); G_epi(36)=1;
        
        SDX2=0*SDX;
        SDX2(:,2)=SDX(:,2);
        SDX2(:,9)=SDX(:,9);
        SDX2=SDX;

        H=[H(1:7,:); B([20 4 8 12 16 40 80],:)]; 
        C=[C(1:7); zeros(7,1)];
        
aa=((1-ALPHA)/(1-RHO))*G_UC*PSI*SDX2 +  ((RHO-ALPHA)/(1-RHO))*G_R*PSI*SDX2;
(aa.^2)./sum(aa.^2)

SS=(G1^10000)*[ones(NY-1,1);1];

        R10=B(19,:)*SS-B(20,:)*SS + B(1,:)*SS;
        R10=400*R10
 
% 400*SS(19)-R10

% p=exp(B*SS).*((1-.0275).^[0:39]')
% p1=exp(B*SS).*((1-.0275).^[0:39]')

% scatter(((1-LL)*IRF(20,:,1)+LL*IRF(19,:,1))',IRF(21,:,1)')
% hold
% scatter(((1-LL)*IRF(20,:,1)+LL*IRF(19,:,1))',((1-LL)*IRF(20,:,1)+LL*IRF(19,:,1))','g+')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%         if isreal(C20)&&isreal(H20)&&isreal(G1)&&isreal(M)
        
            % initializing the Kalman filter
            SS=(G1^10000)*[ones(NY-1,1);1];
            shat=SS;
            Q=M*SDX*SDX'*M';
            sig=disclyap_fast(G1,Q);
            LOGLH=0;
            
            Q(end,:)=0; Q(:,end)=0;
            
%             SS([8,[14:17]])

            % Kalman filter recursion delivering log-likelihood
            x=shat;
            R=zeros(14,14);
            
            R(8:14,8:14)=(param(29).^2)*(diag([20 4 8 12 16 40 80]/4).^2);
            
%             y=y(:,1:13);
%             H=H(1:13,:);
%             C=C(1:13);
%             R=R(1:13,1:13);
            
            
            for t=1:T
                [shat,sig,loglh]=kfilter(y(t,:)',H,C,G1,shat,sig,R,Q);
                LOGLH=LOGLH+loglh;
                LL(t)=loglh;
                x=[x shat];
            end
           
%             plot(zscore([-H(8,:)*x(:,2:end)+C(8); x(18,2:end)]'))
%             
%             err=bsxfun(@plus,y'-H*G1*x(:,1:end-1),-C)';
%             [mean(y)
%                 mean((H*G1*x(:,1:end-1))')
%                 mean((H*x)')
%                 C']
%             
%             spread=-H(8,:)*x(:,2:end);
% 
%             innov=x(:,2:end)-G1*x(:,1:end-1);
%             innov2=inv(M'*M)*M'*innov;
% %             
%             mean(innov2')./(std(innov2')/sqrt(90))
%             
%             rra=1-(1-RHO)*x(30,2:end);
%             rsd=sqrt(squeeze(ssig(30,30,:)))';
%             plot([rra; rra+2*rsd; rra-2*rsd]')
%             %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             
% simulate data
% 
% for num=1:1000
%     disp(num)
%     
%     N=230;
%     X=zeros(length(PHI),N);
%     X(:,1)=SS;
%     for i=2:N
%         X(:,i)=PHI*X(:,i-1) + PSI*SDX*randn(10,1);
%     end
% 
%     ret=H(end,:)*X(:,2:end) - H(7,:)*X(:,1:end-1);
%     eret=X(55,:)-X(9,:)+X(34,:);
%     eret2=H(end,:)*PHI*X - H(7,:)*X;
%     
%     ret20=ret(1:end-20);
%     for i=2:20
%         ret20=ret(i:end-21+i)+ret20;
%     end
% 
%     [~,~,~,~,stats]=regress(ret20(2:end)',[X(29,1:end-22)' ones(N-22,1)]);
%     r2(num)=stats(1);
% end
% 
% er20=X(55,:)-X(9,:)+X(34,:);
% for i=1:19
%     X1=(PHI^i)*X;
%     er20=er20+(X1(55,:)-X1(9,:)+X1(34,:));
% end



% IRF_dc=IRF(8,:,:)-IRF(31,:,:)+IRF(15,:,:);
% IRF_dc=squeeze(IRF_dc)';
% 
% points=[0:.001:.999]'*pi;
% G=cos(points*0)*IRF_dc(1,:);
% for i=1:200
%     G=G + cos(points*i)*IRF_dc(i+1,:);
% end






